unit uArray;

interface

uses
  StrUtils, SysUtils, Classes, DateUtils, Math;

type
  TProdutos = class
  private
    oCodigo : Integer;
    oPreco : Double;
    oDescricao : string;
    oQtde : Integer;
  public
    property Codigo : Integer read oCodigo write oCodigo;
    property Preco : Double read oPreco write oPreco;
    property Descricao : string read oDescricao write oDescricao;
    property Qtde : Integer read oQtde write oQtde;
  end;

  TArrayProdutos = array of TProdutos;

  TCarrinho = class
  private
    oVenda : Integer;
    oLstProdutos : TArrayProdutos;

    function GetItem(aCodigo : Integer) : Integer;
  public
    property Venda : Integer read oVenda write oVenda;
    property LstProdutos : TArrayProdutos read oLstProdutos write oLstProdutos;

    procedure Add(aCodigo, aQtde : Integer; aPreco : Double; aDescricao : string);
    procedure Update(aCodigo, aQtde : Integer; aPreco : Double; aDescricao : string);
    procedure Delete(aCodigo : Integer);
    function Show : string;

    constructor Create;
    destructor Destroy;
  end;

implementation

{ TCarrinho }

procedure TCarrinho.Add(aCodigo, aQtde: Integer; aPreco: Double; aDescricao: string);
begin
  SetLength(oLstProdutos, Length(oLstProdutos) + 1);
  LstProdutos[High(oLstProdutos)] := TProdutos.Create;
  LstProdutos[High(oLstProdutos)].Codigo := aCodigo;
  LstProdutos[High(oLstProdutos)].Qtde := aQtde;
  LstProdutos[High(oLstProdutos)].Preco := aPreco;
  LstProdutos[High(oLstProdutos)].Descricao := aDescricao;
end;

constructor TCarrinho.Create;
begin
  SetLength(oLstProdutos, 0);
end;

procedure TCarrinho.Delete(aCodigo: Integer);
var
  vIndexItem : Integer;
begin
  vIndexItem := Self.GetItem(aCodigo);
  LstProdutos[vIndexItem].Codigo := -1;
end;

destructor TCarrinho.Destroy;
var
  I : Integer;
begin
  for I := Low(LstProdutos) to High(LstProdutos) do begin
    LstProdutos[I].Destroy;
  end;

  SetLength(oLstProdutos, 0);
end;

function TCarrinho.GetItem(aCodigo: Integer): Integer;
var
  I : Integer;
begin
  Result := -1;
  for I := Low(LstProdutos) to High(LstProdutos) do begin
    if (aCodigo = LstProdutos[I].Codigo) then begin
      Result := I;
      Break;
    end;
  end;
end;

function TCarrinho.Show: string;
var
  I : Integer;
begin
  Result := '';
  for I := Low(LstProdutos) to High(LstProdutos) do begin
    Result := 'Codigo: ' + IntToStr(LstProdutos[I].Codigo) + #13#10+
              'Descriao: ' + LstProdutos[I].Descricao + #13#10 +
              'Preo: ' + FormatFloat('0.00', LstProdutos[I].Preco) + #13#10 +
              'Quantidade: ' + IntToStr(LstProdutos[I].Qtde) + #13#10+
              '----------------------------------------------'#13#10;
  end;
end;

procedure TCarrinho.Update(aCodigo, aQtde: Integer; aPreco: Double; aDescricao: string);
var
  vItemIndex : Integer;
begin
  vItemIndex := Self.GetItem(aCodigo);
  LstProdutos[vItemIndex].Codigo := aCodigo;
  LstProdutos[vItemIndex].Qtde := aQtde;
  LstProdutos[vItemIndex].Descricao := aDescricao;
  LstProdutos[vItemIndex].Preco := aPreco;
end;

end.
