unit uList;

interface

uses
  StrUtils, SysUtils, Classes, DateUtils, Math;

type
  TProdutos = class
  private
    oCodigo : Integer;
    oPreco : Double;
    oDescricao : string;
    oQtde : Integer;
  public
    property Codigo : Integer read oCodigo write oCodigo;
    property Preco : Double read oPreco write oPreco;
    property Descricao : string read oDescricao write oDescricao;
    property Qtde : Integer read oQtde write oQtde;
  end;

  TCarrinho = class
  private
    oVenda : Integer;
    oLstProdutos : TList;

    function GetItem(aCodigo : Integer) : Integer;
  public
    property Venda : Integer read oVenda write oVenda;
    property LstProdutos : TList read oLstProdutos write oLstProdutos;

    procedure Add(aCodigo, aQtde : Integer; aPreco : Double; aDescricao : string);
    procedure Update(aCodigo, aQtde : Integer; aPreco : Double; aDescricao : string);
    procedure Delete(aCodigo : Integer);

    constructor Create;
    destructor Destroy;
  end;

implementation

{ TCarrinho }

procedure TCarrinho.Add(aCodigo, aQtde: Integer; aPreco: Double; aDescricao: string);
var
  vProduto : TProdutos;
begin
  vProduto := TProdutos.Create;
  vProduto.Codigo := aCodigo;
  vProduto.Qtde := aQtde;
  vProduto.Preco := aPreco;
  vProduto.Descricao := aDescricao;
  oLstProdutos.Add(vProduto);
end;

constructor TCarrinho.Create;
begin
  oLstProdutos := TList.Create;
end;

procedure TCarrinho.Delete(aCodigo: Integer);
var
  vIndexItem : Integer;
begin
  vIndexItem := Self.GetItem(aCodigo);
  LstProdutos.Delete(vIndexItem);
end;

destructor TCarrinho.Destroy;
var
  I : Integer;
begin
  for I := 0 to oLstProdutos.Count - 1 do begin
    TProdutos(LstProdutos[I]).Destroy;
  end;

  oLstProdutos.Destroy;
end;

function TCarrinho.GetItem(aCodigo: Integer): Integer;
var
  I : Integer;
begin
  Result := -1;
  for I := 0 to oLstProdutos.Count - 1 do begin
    if (aCodigo = TProdutos(LstProdutos[I]).Codigo) then begin
      Result := I;
      Break;
    end;
  end;
end;

procedure TCarrinho.Update(aCodigo, aQtde: Integer; aPreco: Double; aDescricao: string);
var
  vItemIndex : Integer;
begin
  vItemIndex := Self.GetItem(aCodigo);
  TProdutos(LstProdutos[vItemIndex]).Codigo := aCodigo;
  TProdutos(LstProdutos[vItemIndex]).Qtde := aQtde;
  TProdutos(LstProdutos[vItemIndex]).Descricao := aDescricao;
  TProdutos(LstProdutos[vItemIndex]).Preco := aPreco;
end;

end.
