unit uDBGrid;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DB, DBClient, Grids, DBGrids, Math, ImgList, ADODB;

type
  TColumnWidthHelper = record
   Index : integer;
   MaxWidth : integer;
  end;

type
  THackDBGrid = class(TDBGrid) ;

type
  TForm1 = class(TForm)
    dbgGridExemplo: TDBGrid;
    cdsCadastro: TClientDataSet;
    cdsCadastroNome: TStringField;
    cdsCadastroEndereco: TStringField;
    cdsCadastroTelefone: TStringField;
    cdsCadastroDtaNascimento: TDateField;
    cdsCadastroCodigo: TIntegerField;
    dtsCadastro: TDataSource;
    dbgExAutoFit: TDBGrid;
    imlImageList: TImageList;
    procedure dbgGridExemploKeyPress(Sender: TObject; var Key: Char);
    procedure dbgGridExemploKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure dbgGridExemploDblClick(Sender: TObject);
    procedure FixDBGridColumnsWidth(const DBGrid: TDBGrid);
    procedure FormResize(Sender: TObject);
    procedure dbgExAutoFitDblClick(Sender: TObject);
    procedure dbgExAutoFitDrawColumnCell(Sender: TObject; const Rect: TRect; DataCol: Integer; Column: TColumn;
      State: TGridDrawState);
    procedure cdsCadastroNomeGetText(Sender: TField; var Text: string; DisplayText: Boolean);
    procedure dbgGridExemploDrawColumnCell(Sender: TObject; const Rect: TRect; DataCol: Integer; Column: TColumn;
      State: TGridDrawState);
    procedure dbgGridExemploTitleClick(Column: TColumn);
    procedure dbgExAutoFitMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
    ColumnWidthHelper: TColumnWidthHelper;
    fMouseOverRow: integer;
    procedure SetMouseOverRow(const Value: integer) ;
    property MouseOverRow : integer read fMouseOverRow write SetMouseOverRow;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.cdsCadastroNomeGetText(Sender: TField; var Text: string; DisplayText: Boolean);
begin
    Text:= (Sender as TField).AsString;
end;

procedure TForm1.dbgExAutoFitDblClick(Sender: TObject);
var
   mouseInGrid : TPoint;
   gridCoord: TGridCoord;
begin
  //Convert "Screen" do mouse para "Grid" Mouse
  mouseInGrid := dbgExAutoFit.ScreenToClient(Mouse.CursorPos) ;
  gridCoord := dbgExAutoFit.MouseCoord(mouseInGrid.X, mouseInGrid.Y) ;

  //Ttulo da coluna no  exibida?
  if not (dgTitles in dbgExAutoFit.Options) then Exit;

  //Ttulos exibidos, mas ns duplo clique em "linha" regular?
  if gridCoord.Y <> 0 then Exit;

  //Localiza o indice da coluna
  if dgIndicator in dbgExAutoFit.Options then
    ColumnWidthHelper.Index := -1 + gridCoord.x
  else
    ColumnWidthHelper.Index := gridCoord.x;

  //Indica que localizou a coluna
  if ColumnWidthHelper.Index < 0 then Exit;

  ColumnWidthHelper.MaxWidth := -1;

  //"recalcula" ColumnWidthHelper.MaxWidth
  dbgExAutoFit.Repaint;

  //"auto size" Ajusta a largura da coluna
  if ColumnWidthHelper.MaxWidth > 0 then
    dbgExAutoFit.Columns[ColumnWidthHelper.Index].Width := 4 + ColumnWidthHelper.MaxWidth;

end;

procedure TForm1.dbgExAutoFitDrawColumnCell(Sender: TObject; const Rect: TRect; DataCol: Integer; Column: TColumn;
  State: TGridDrawState);
begin
  //se esta  a coluna que queremos auto-tamanho?
  if DataCol = ColumnWidthHelper.Index then
  begin
   //A coluna tem campo?
   if Assigned(Column.Field) then
   begin
    //Encontra o tamanho maxmo
    ColumnWidthHelper.MaxWidth := Max(ColumnWidthHelper.MaxWidth, dbgExAutoFit.Canvas.TextWidth(Column.Field.DisplayText)) ;
   end;
  end;

  if NOT ((gdFocused in State) or (gdSelected in State))
     AND (MouseOverRow = 1 + THackDBGrid(dbgExAutoFit).DataLink.ActiveRecord) then
  begin
    with dbgExAutoFit.Canvas do
    begin
      Brush.Color := clSilver;
      Font.Color := clNavy;
    end;
  end;

  //desenhar o texto predefinido (posio fixa) aps a imagem.
  dbgExAutoFit.DefaultDrawColumnCell(Rect, DataCol, Column, State) ;

end;

procedure TForm1.dbgExAutoFitMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
var
  pt: TGridcoord;
  gc: TGridCoord;
begin
  pt:= dbgGridExemplo.MouseCoord(x, y);

  if pt.y=0 then
    dbgExAutoFit.Cursor:=crHandPoint
  else
    dbgExAutoFit.Cursor:=crDefault;

  gc := dbgExAutoFit.MouseCoord(x, y) ;

  MouseOverRow := gc.Y;
end;

procedure TForm1.dbgGridExemploDblClick(Sender: TObject);
begin
  ShowMessage(IntToStr(dbgGridExemplo.DataSource.DataSet.RecNo));
end;

procedure TForm1.dbgGridExemploDrawColumnCell(Sender: TObject; const Rect: TRect; DataCol: Integer; Column: TColumn;
  State: TGridDrawState);
var
  bitmap : TBitmap;
  fixRect : TRect;
  bmpWidth : integer;

  imgIndex : integer;
begin
  fixRect := Rect;

  // ID (Nmero) da coluna que ser inserido a imagem
  if Column.ID = 1 then
  begin

    //Indice da imagem no ImageList.
    //Nesta parte voc pode usar a criatividade com o IF e usar varias imagens dependendo das
    //condies que voc estipular.
    imgIndex := 0;

    bitmap := TBitmap.Create;
    try
      //Pega a imagem do ImageList
      imlImageList.GetBitmap(imgIndex,bitmap);
      //Calcula a dimenso da imagem
      bmpWidth := (Rect.Bottom - Rect.Top);
      fixRect.Right := Rect.Left + bmpWidth;
      //desenha a imagem no DBGrid
      dbgGridExemplo.Canvas.StretchDraw(fixRect,bitmap);
    finally
      bitmap.Free;
    end;

    // Adicionar o espao para os grficos
    fixRect := Rect;
    fixRect.Left := fixRect.Left + bmpWidth;
  end;

  //desenhar o texto predefinido (posio fixa) aps a imagem.
  dbgGridExemplo.DefaultDrawColumnCell(
     fixRect,
     DataCol,
     Column,
     State);

end;

procedure TForm1.dbgGridExemploKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if (Key = VK_DELETE)  and ((Shift = [SsCtrl]) or (Shift = [SsCtrl,ssShift]))  then
    Key:= 0;

end;

procedure TForm1.dbgGridExemploKeyPress(Sender: TObject; var Key: Char);
begin
   If Key = #13 Then
   Begin
    If HiWord(GetKeyState(VK_SHIFT)) <> 0 then
    begin
     with (Sender as TDBGrid) do
     begin
       if selectedindex > 0 then
        selectedindex := selectedindex - 1
       else begin
        DataSource.DataSet.Prior;
        selectedindex := fieldcount - 1;
       end;
     end;
    end else
    begin
     with (Sender as TDBGrid) do
     begin
       if selectedindex < (fieldcount - 1) then
        selectedindex := selectedindex + 1
       else begin
        DataSource.DataSet.Next;
        selectedindex := 0;
       end;
     end;
   end;
   Key := #0
   end;
end;

procedure TForm1.dbgGridExemploTitleClick(Column: TColumn);
Var
 PreviousColumnIndex : integer;
begin
  PreviousColumnIndex := -1;

  if dbgGridExemplo.DataSource.DataSet is TCustomADODataSet then
  with TCustomADODataSet(dbgGridExemplo.DataSource.DataSet) do
  begin
    try
      dbgGridExemplo.Columns[PreviousColumnIndex].title.Font.Style :=
      dbgGridExemplo.Columns[PreviousColumnIndex].title.Font.Style - [fsBold];
    except
    end;

    Column.title.Font.Style := 
    Column.title.Font.Style + [fsBold];
    PreviousColumnIndex := Column.Index;

    if (Pos(Column.Field.FieldName, Sort) = 1)
    and (Pos(' DESC', Sort)= 0) then
      Sort := Column.Field.FieldName + ' DESC'
    else
      Sort := Column.Field.FieldName + ' ASC';
  end;

end;

procedure TForm1.FixDBGridColumnsWidth(const DBGrid: TDBGrid);
var
  i : integer;
  TotWidth : integer;
  VarWidth : integer;
  ResizableColumnCount : integer;
  AColumn : TColumn;
begin
  //largura total de todas as colunas antes de redimensionar
  TotWidth := 0;
  //como dividir qualquer espao extra na rede
  VarWidth := 0;
  //quantas colunas precisam ser auto-redimensionada
  ResizableColumnCount := 0;

  //Tamabo padro da primeira coluna
  DBGrid.Columns[0].Field.Tag := 20;
  //Tamabo padro da segunda coluna
  DBGrid.Columns[1].Field.Tag := 10;

  for i := 0 to -1 + DBGrid.Columns.Count do
  begin
    TotWidth := TotWidth + DBGrid.Columns[i].Width;
    if DBGrid.Columns[i].Field.Tag <> 0 then
      Inc(ResizableColumnCount);
  end;

  //add 1px para a linha de separador de coluna
  if dgColLines in DBGrid.Options then
    TotWidth := TotWidth + DBGrid.Columns.Count;

  //dd a largura da coluna indicador
  if dgIndicator in DBGrid.Options then
    TotWidth := TotWidth + IndicatorWidth;

  //Vale a largura de "esquerda"
  VarWidth :=  DBGrid.ClientWidth - TotWidth;

  // Igualmente distribuir VarWidth
  // para todos os auto-colunas redimensionvel
  if ResizableColumnCount > 0 then
    VarWidth := varWidth div ResizableColumnCount;

  for i := 0 to -1 + DBGrid.Columns.Count do
  begin
    AColumn := DBGrid.Columns[i];
    if AColumn.Field.Tag <> 0 then
    begin
      AColumn.Width := AColumn.Width + VarWidth;
      if AColumn.Width < AColumn.Field.Tag then
        AColumn.Width := AColumn.Field.Tag;
    end;
  end;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
 FixDBGridColumnsWidth(dbgGridExemplo);
end;

procedure TForm1.SetMouseOverRow(const Value: integer);
begin
  if fMouseOverRow <> Value then
  begin
    fMouseOverRow := Value;
    dbgExAutoFit.Repaint;
  end;
end;

end.
